#include <iostream>

#include "./common.h"
#include "./types.h"
#include "./geom.h"

using namespace std;

extern int window_width;
extern int window_height;
extern float window_aspect;

void TimerCallback(int value) {
  glutPostRedisplay();
}

void Redisplay(int milliseconds) {
  glutTimerFunc(milliseconds, TimerCallback, 0);
}

void DrawRed() {
  glColor3f(1, 0, 0);
  glBegin(GL_TRIANGLES);
  glVertex3f(-10, 0, 10);
  glVertex3f(10, 0, 10);
  glVertex3f(0, 15, 10);
  glEnd();
}

void DrawBlue() {
  glColor3f(0, 0, 1);
  glBegin(GL_TRIANGLES);
  glVertex3f(-10, 0, -10);
  glVertex3f(10, 0, -10);
  glVertex3f(0, 15, -10);
  glEnd();
}

void DrawTriangles() {
  DrawRed();
  DrawBlue();
}

void Display1() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Quick example in perspective to see what is going on
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(40.0,window_aspect,1,1500);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(15, 20, 45,
            0, 5, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display2() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) both triangles
  //  B) red triangle
  //  C) blue triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  // changed here
  glOrtho(-10, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  // changed here
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display3() {
  // changed here
  // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glClear(GL_COLOR_BUFFER_BIT);

  // What is rendered?
  //  A) both triangles
  //  B) red triangle
  //  C) blue triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-10, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display4() {
  // changed here
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glDepthFunc(GL_LEQUAL);  // <= depth test
  glDepthMask(GL_FALSE);  // disable depth buffer writes

  // What is rendered?
  //  A) both triangles
  //  B) red triangle
  //  C) blue triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-10, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();

  // changed here
  DrawRed();
  DrawBlue();

  glFlush();
  glutSwapBuffers();
}

void Display5() {
  // changed here
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  // glClear(GL_COLOR_BUFFER_BIT);

  static int count = 0;

  // What is rendered?
  //  A) both triangles
  //  B) red triangle
  //  C) blue triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-10, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  // changed here
  if (count % 2 == 0)
    DrawRed();
  else
    DrawBlue();

  ++count;

  glFlush();
  glutSwapBuffers();
  // changed here
  Redisplay(1000);
}

void Display6() {
  // changed here
  // glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glClear(GL_COLOR_BUFFER_BIT);

  static int count = 0;

  // What is rendered?
  //  A) both triangles
  //  B) red triangle
  //  C) blue triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-10, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  if (count % 2 == 0)
    DrawRed();
  else
    DrawBlue();

  ++count;

  glFlush();
  glutSwapBuffers();
  Redisplay(1000);
}

void Display7() {
}

void Display8() {
}

void Display9() {
}

void Display10() {
}

void Display11() {
}

void Display12() {
}

void Display13() {
}
