#include <iostream>

#include "./common.h"
#include "./types.h"
#include "./geom.h"

using namespace std;

extern int window_width;
extern int window_height;
extern float window_aspect;

void TimerCallback(int value) {
  glutPostRedisplay();
}

void Redisplay(int milliseconds) {
  glutTimerFunc(milliseconds, TimerCallback, 0);
}

void Display1() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  DisableLighting();
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glColor3f(1, 0, 0);
  glBegin(GL_POLYGON);
  glVertex3f(-5, 5, 0);
  glVertex3f(-5, -5, 0);
  glVertex3f(5, -5, 0);
  glVertex3f(5, 5, 0);
  glVertex3f(0, 0, 0);
  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Display2() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  // disable color buffer writes
  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
  // disable depth buffer writes
  glDepthMask(GL_FALSE);
  // enable stencil test
  glEnable(GL_STENCIL_TEST);
  // any write to stencil buffer flips the bit
  glStencilFunc(GL_ALWAYS, 0x1, 0x1);
  glStencilOp(GL_INVERT, GL_INVERT, GL_INVERT);

  DisableLighting();
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glColor3f(1, 0, 0);
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(-5, 5, 0);
  glVertex3f(-5, -5, 0);
  glVertex3f(5, -5, 0);
  glVertex3f(5, 5, 0);
  glVertex3f(0, 0, 0);
  glEnd();

  // re-enable color buffer writes
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  // re-enable depth buffer writes
  glDepthMask(GL_TRUE);

  // Draw entire block
  glStencilFunc(GL_EQUAL, 0x1, 0x1);
  glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
  glBegin(GL_QUADS);
  glVertex3f(-10, -10, 0);
  glVertex3f(10, -10, 0);
  glVertex3f(10, 10, 0);
  glVertex3f(-10, 10, 0);
  glEnd();

  glFlush();
  glutSwapBuffers();

  glDisable(GL_STENCIL_TEST);
}

void Display3() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  // disable color buffer writes
  glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
  // disable depth buffer writes
  glDepthMask(GL_FALSE);
  // enable stencil test
  glEnable(GL_STENCIL_TEST);
  // any write to stencil buffer flips the bit
  glStencilFunc(GL_ALWAYS, 0x1, 0x1);
  glStencilOp(GL_INVERT, GL_INVERT, GL_INVERT);

  DisableLighting();
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glColor3f(1, 0, 0);
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(-8, -10, 0);
  glVertex3f(0, 10, 0);
  glVertex3f(8, -10, 0);
  glVertex3f(-10, 5, 0);
  glVertex3f(10, 5, 0);
  glEnd();

  // re-enable color buffer writes
  glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
  // re-enable depth buffer writes
  glDepthMask(GL_TRUE);

  glStencilFunc(GL_EQUAL, 0x1, 0x1);
  glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
  glBegin(GL_QUADS);
  glVertex3f(-10, -10, 0);
  glVertex3f(10, -10, 0);
  glVertex3f(10, 10, 0);
  glVertex3f(-10, 10, 0);
  glEnd();

  glFlush();
  glutSwapBuffers();

  glDisable(GL_STENCIL_TEST);
}

void Display4() {
}

void Display5() {
}

void Display6() {
}

void Display7() {
}

void Display8() {
}

void Display9() {
}

void Display10() {
}

void Display11() {
}

void Display12() {
}

void Display13() {
}
