#include <vector>

#include "./common.h"
#include "./ball.h"

extern int window_width;
extern int window_height;
extern bb2 bb;
extern point2 mouse_down;
extern double vel_f;
extern bool down;
extern point2 mouse_cur;
extern Ball ball;
extern Ball ball2;
extern std::vector<Ball> balls;
int num_balls = 3;

point2 win2obj(const point2& p);
void hit(const point2& P, const point2& Q);
void DrawLine(const point2& a, const point2& b);

void DrawBalls() {
  for (int i = 0; i < num_balls; ++i) {
    balls[i].draw();
  }

  ball.draw();
  ball2.draw();
}

void Display1() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();

  // One end of the line drawn is
  //  A) on the cue ball
  //  B) on the mouse
  //  C) in the corner pocket
  //  D) none of the above
  if (mouse_cur.x() != mouse_down.x() || mouse_cur.y() != mouse_down.y()) {
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
  }

  glFlush();
  glutSwapBuffers();
}

void MouseMotion1(int x, int y) {
  if (down) {
    mouse_cur = point2(x, window_height-y);
  }
  glutPostRedisplay();
}

void Display2() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();

  // Line draw deleted

  glFlush();
  glutSwapBuffers();
}

void MouseMotion2(int x, int y) {
  if (down) {
    mouse_cur = point2(x, window_height-y);
    // Which is true?
    //  A) no lines are drawn
    //  B) the line is drawn more efficiently
    //  C) many lines are drawn
    //  D) none of the above
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
    glFlush();
  }
}

void Display3() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();
  glFlush();
  glutSwapBuffers();
}

void MouseMotion3(int x, int y) {
  glDrawBuffer(GL_FRONT);

  if (down) {
    mouse_cur = point2(x, window_height-y);
    // Which is true?
    //  A) no lines are drawn
    //  B) the line is drawn more efficiently
    //  C) many lines are drawn
    //  D) none of the above
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
    glFlush();
  }

  glDrawBuffer(GL_BACK);
}

void Display4() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();
  glFlush();
  glutSwapBuffers();
}

void MouseMotion4(int x, int y) {
  glEnable(GL_COLOR_LOGIC_OP);
  glDrawBuffer(GL_FRONT);

  if (down) {
    mouse_cur = point2(x, window_height-y);

    // Which is true?
    //  A) no lines are drawn
    //  B) the line is drawn more efficiently
    //  C) many lines are drawn
    //  D) none of the above
    glLogicOp(GL_XOR);
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
    glFlush();
    glLogicOp(GL_COPY);
  }

  glDrawBuffer(GL_BACK);
}

void Display5() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();
  glFlush();
  glutSwapBuffers();
}

void MouseMotion5(int x, int y) {
  glEnable(GL_COLOR_LOGIC_OP);
  glDrawBuffer(GL_FRONT);

  if (down) {
    // Which is true?
    //  A) no lines are drawn
    //  B) the line is drawn more efficiently
    //  C) many lines are drawn
    //  D) none of the above
    glLogicOp(GL_XOR);
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));

    mouse_cur = point2(x, window_height-y);

    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
    // glFlush();
    glLogicOp(GL_COPY);
  }

  glDrawBuffer(GL_BACK);
}

void Display6() {
  glClear(GL_COLOR_BUFFER_BIT);
  DrawBalls();
  glFlush();
  glutSwapBuffers();
}

void MouseMotion6(int x, int y) {
  glEnable(GL_COLOR_LOGIC_OP);
  glDrawBuffer(GL_FRONT);

  if (down) {
    // Which is true?
    //  A) no lines are drawn
    //  B) the line is drawn more efficiently
    //  C) many lines are drawn
    //  D) none of the above
    glLogicOp(GL_XOR);
    glColor3f(1, 1, 1);
    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));

    mouse_cur = point2(x, window_height-y);

    DrawLine(win2obj(mouse_down), win2obj(mouse_cur));
    glFlush();
    glLogicOp(GL_COPY);
  }

  glDrawBuffer(GL_BACK);
}
